"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtractorPlugin = void 0;
const Plugin_1 = __importDefault(require("./Plugin"));
/**
 * Extractor Plugin
 * @extends Plugin
 * @abstract
 */
class ExtractorPlugin extends Plugin_1.default {
    constructor() {
        super(...arguments);
        this.type = "extractor";
    }
}
exports.ExtractorPlugin = ExtractorPlugin;
/**
 * Resolve the validated url to a {@link Song} or a {@link Playlist}.\
 * Not needed to add {@link Song#related} because it will be added with {@link Plugin#getRelatedSongs}.
 * @param {string} url URL
 * @param {Discord.GuildMember} member Requested user
 * @returns {Promise<Song|Song[]|Playlist>}
 * @method resolve
 * @memberof ExtractorPlugin#
 * @abstract
 */
exports.default = ExtractorPlugin;
//# sourceMappingURL=ExtractorPlugin.js.map